/*
 * Copyright (C) 2000  Thomas Mirlacher
 * Patched to I420 colourspace (12bits) and reverse vertical by Jarl van Katwijk
 * 
 *
 */

#include <sys/types.h>
#include <glib.h>
#include "spu.h"

//#define DEBUG
#undef DEBUG

//static gint aligned;
static guint16 field = 0;
//static guint8 *byte_pos;

/* Proto's */
void overlay(guint8 *background[3],gint xb,gint yb,gint ob,struct spu_img_struct *spu,gdouble o1);


/* Mixing function for YV12 mode */
static inline void display_mix_function_yuv(guint32 color, guint32 contrast, guint8 *y_pixel, gint field, guint8 *u_pixel, guint8 *v_pixel) {
    register gint n = 0;
    register guint32 invcontrast = 256 - contrast;
    register guint8 y, u, v;
    register guint32 py;
    static gint odd;
    static guint32 pu, pv;

    u = (color >> 16) & 0xff;
    v = (color >> 8) & 0xff;
    y = color & 0xff;

    /* if no transparancy just overwrite */
    if (contrast == (0xf<<4)) {
        y_pixel[0] = y;
        /* only write uv on even columns and rows */
        if (!field) {
            gint odd = (gint)y_pixel & 1;
            for(n = odd; n < (2 - odd)>>1; n++) {
                u_pixel[n] = u;
                v_pixel[n] = v;
            }
        } 
    } else {
        py = y_pixel[0];
        py = (py * invcontrast + y * contrast) >> 8;
        y_pixel[0] = py;
        /* only write uv on even columns and rows */
        if (!field) {
            odd = (gint)y_pixel & 1;
            for (n = odd; n < (2 - odd)>>1; n++) {
                pu = u_pixel[n];
                pu = (pu * invcontrast + u * contrast) >> 8;
                u_pixel[n] = pu;
                pv = v_pixel[n];
                pv = (pv * invcontrast + v * contrast) >> 8;
                v_pixel[n] = pv;
            }
        }  
    }
    return;
}

void overlay(guint8 *background[3],gint xb,gint yb,gint ob,struct spu_img_struct *spu,gdouble o1) {
    static glong x,y,y2;
    static guint32 colour,contrast;
    static guchar *spu_data_ptr;
    static glong line_y,line_y2,offset,offset2;
    static gchar *addr,*addr_u, *addr_v;

    #ifdef DEBUG
    g_log(SPU_LD,G_LOG_LEVEL_DEBUG,"SPU: Overlaying x=%i, y=%i, spu->x=%i, spu->y=%i, spu->height=%i, spu->width=%i, spu->ybase=%i,  background[0] = %p, background[1] = %p, background[2] = %p",xb,yb,spu->x,spu->y,spu->height,spu->width,spu->ybase,background[0],background[1],background[2]);
    #endif
    spu_data_ptr = (guchar*)((glong)spu->data + spu->height * spu->width);
    addr = background[0];// + offset;
    addr_u = background[1];
    addr_v = background[2];

    /* SPU render offset */
    y2 = spu->y - spu->clipbottom;
    if (y2 < spu->cliptop) y2 = spu->cliptop;

    for (y=spu->height-1; y>-1; y--) {
        line_y  = (y + y2) * xb;
        line_y2 = ((y + y2)>>1) * (xb>>1); // /2 replaced by >>1
        if (line_y < spu->cliptop) line_y = spu->cliptop * xb; // If due to clipping subs are located outside visible area: draw from top
        offset = line_y + spu->x + spu->clipleft>>1; // /2 replaced by >>1
        for (x=spu->width-1; x>-1; x--) {
            /* Define colour and contrast */
            colour = (*spu_data_ptr)&0xF;
            contrast = (guint32)(((*spu_data_ptr)&0xF0)*o1);
            /* Overlay if not completely transparant */
            if (contrast != 0) {
                addr = background[0] + offset + x;
                offset2 = line_y2 + (x + spu->x + spu->clipleft>>1)>>1; // /2 replaced by >>1
                addr_u = background[1] + offset2;
                addr_v = background[2] + offset2;
                #ifdef DEBUG
//                g_log(SPU_LD,G_LOG_LEVEL_DEBUG,"SPU: colour=%u (COL=%i), contrast=%u",spu_clut[colour],(*spu_data_ptr)&0xF,contrast);
                #endif
                display_mix_function_yuv(spu_clut[colour], contrast, addr, field, addr_u, addr_v);
            }
            spu_data_ptr--;
        }
        field = 1-field;  /* even\odd fields */
    }
    return;
}

